
var App = {

   Menu:null,
   OrderCostTotal:0,
   PendingOrderKey:"PendingOrder",
   UsedAddressesKey:"UsedAddresses",
   DeliveryAddresskey:"DeliveryAddress",
   AddressIDSelected:null,
   RefreshCycle:4000,
   OrderStatus:["Canceled", "Order Placed", "Order Queued", "We Are Preparing Your Food", "In The Oven / Cooking", "Out For Delivery"],

   Init:function(){

      this.Menu = JoesPizza.Menu;
      $("#PizzaOrderNext").click(this.OrderNext);
      
   },

   InitSubmit:function(){

      this.LoadOrderDetails();
      this.LoadOrderAddress();

   },

   LoadMenu:function(){

      $("#MenuItemList").html("");
      
      this.Menu.items.forEach(item => {
         let html = HtmlCode.GetMenuItem(item);
         $("#MenuItemList").append(html);
      });

      // attach click events to new menu items
      let selector = "div[act=\"add2order\"]";
      $(selector).click(function(){
         // readd values from the clicked menu item
         let lbl = $(this).attr("lbl");
         let cost = $(this).attr("cost");
         App.OrderCostTotal += parseFloat(cost);
         // html order item
         let html = HtmlCode.GetOrderItem({"lbl":lbl, "cost":cost});
         $("#PizzaOrderItems").append(html);
         App.OnAddUpdateOrderTotal();
         // attach click events on order items
         // add remove method; this can be improved
         $(".order-item").off("click");
         $(".order-item").click(function(){
            let cost = $(this).attr("cost");
            App.OrderCostTotal -= parseFloat(cost);
            App.OnRemoveUpdateOrderTotal();
            $(this).remove();
         });
      });

   },

   OnAddUpdateOrderTotal:function(){

      // needs correction
      let selector = "#PizzaOrderSummary, #PizzaOrderNext";
      $(selector).css("visibility", "visible");
      let total = "$" + App.OrderCostTotal.toFixed(2);
      selector = "#PizzaOrderSummary > div:nth-child(2)";
      $(selector).html(total);

   },

   OnRemoveUpdateOrderTotal:function(cost){

      // needs correction
      if($(".order-item").length == 1){
         let selector = "#PizzaOrderSummary, #PizzaOrderNext";
         $(selector).css("visibility", "hidden");  
         return false;
      }else{
         let total = "$" + App.OrderCostTotal.toFixed(2);
         let selector = "#PizzaOrderSummary > div:nth-child(2)";
         $(selector).html(total);
         return true;
      }
      
   },

   OrderNext:function(){

      if($(".order-item").length == 0){
         alert("There seems to be a problem with your order.");
         return false;
      }

      // read order info
      let arr = []; var total = 0;
      $(".order-item").each((idx, item) => {
         let lbl = $(item).attr("lbl");
         let cost = $(item).attr("cost");
         arr.push({"lbl":lbl, "cost":cost});
      });

      // store order into
      // https://developer.mozilla.org/en-US/docs/Web/API/Window/localStorage
      let json = JSON.stringify(arr);
      localStorage.setItem(App.PendingOrderKey, json);

      // move to submit page
      window.location.assign("/submit/");

   },

   LoadOrderDetails:function(){

      let buff = localStorage.getItem(App.PendingOrderKey);
      let order = JSON.parse(buff);

      order.forEach(item => {
         App.OrderCostTotal += parseFloat(item.cost);
         let html = HtmlCode.GetOrderDetailsItem(item);
         $("#OrderDetails").append(html);
      });

      let data = {"lbl":"Total Cost:", "cost":App.OrderCostTotal.toFixed(2)};
      let html = HtmlCode.GetOrderDetailsItem(data);
      $("#OrderDetails").append(html);

   },

   LoadOrderAddress:function(){

      let buff = localStorage.getItem(App.UsedAddressesKey);
      if(buff == null){
         let html = "<div>Enter address to deliver your pizza</div>";
         $("#AddressSelect").html(html);
      }else{
         let adrs = JSON.parse(buff);
         let html = HtmlCode.GetAddressSelector("SelDelAdr", adrs);
         $("#AddressSelect").html(html);
         /* attach events */
         $("#SelDelAdr").change(function(){
            App.AddressIDSelected = parseInt($(this).val());
            let adr = adrs[App.AddressIDSelected];
            $("#txtStreetAddress").val(adr.street);
            $("#txtCity").val(adr.city);
            $("#txtZipCode").val(adr.zcode);
         });
      }

      let selector = ".address-lines > div:last-child";
      $(selector).click(App.PrePostOrder);

   },

   PrePostOrder:function(){

      /* read address info */
      let street = $("#txtStreetAddress").val();
      let city = $("#txtCity").val();
      let zcode = $("#txtZipCode").val();

      /* homework... validate address info */
      if(!App.ValidateAddressData(street, city, zcode)){
         alert("Please correct address info.");
         return false;
      }

      /* create and store delivery address */
      let adr = {"street":street, "city":city, "zcode": zcode};
      localStorage.setItem(App.DeliveryAddresskey, JSON.stringify(adr));

      /* cache address */
      App.CacheCurrentAddress(adr);

       /*
         here we are ready to submit our pizza order to joe's pizzeria
         we hide currrent frame and bring up status frame
         http://api.jquery.com/fadeOut/
      */

      $(".submit-delivery").fadeOut(500, () => {
         $(".submit-status").fadeIn(500, () => {
            App.PostOrder();
         })
      });

   },

   CacheCurrentAddress:function(adr){

      if(App.AddressIDSelected != null)
         return false;

      let buff = localStorage.getItem(App.UsedAddressesKey);
      let arr = (buff) ? JSON.parse(buff) : [];
      if(App.IsAddressCached(arr, adr))
         return false;

      arr.push(adr);
      buff = JSON.stringify(arr);
      localStorage.setItem(App.UsedAddressesKey, buff);

   },

   IsAddressCached:function(arr, adr){

      let rval = false;
      let street = adr.street.trim();

      for(let idx in arr){
         let buff = arr[idx].street.trim();
         if(buff === street){
            rval = true;
            break;
         }
      }

      return rval;

   },

   ValidateAddressData:function(street, city, zcode){
      
	  let rval = true;
	  /*
         check if passed values are null, undefined or empty strings
         if so reject... return false;
         
         rval = false;
	  */
	  
	  return rval;
   },

   PostOrder:function(){

      let order = localStorage.getItem(App.PendingOrderKey);
      let addr = localStorage.getItem(App.DeliveryAddresskey);

      /* place order */
      let backend = new ClientBackend();
      backend.PostOrder(order, addr, (msg) => {

         let orderid = parseInt(msg);
         if(orderid){
            $("#feedbackMsg").html(`Your Order ID: ${orderid}`);
            /* start to monitor order status */
            setInterval(App.MonitorOrderStatus, App.RefreshCycle, orderid);
         }else{
            $("#feedbackMsg").html(msg);   
         }

      });

   },

   MonitorOrderStatus:function(orderid){

      let backend = new ClientBackend();
      backend.MonitorOrderStatus(orderid, (scode) => {
         let status = App.OrderStatus[parseInt(scode)];
         let dts = new Date().toLocaleTimeString();
         let msg = `Your Order ID: ${orderid}; <i>${status};</i> ${dts}`;
         $("#feedbackMsg").html(msg);
      });

   }  

}