
/* 
   as of ES6
   http://es6-features.org/#StringInterpolation
*/

var HtmlCode = {

   GetMenuItem:function(item){

      let plg = item.choices[0];
      let prg = item.choices[1];
      let lbl_plg = `${item.type} - ${item.name} - ${plg.size}`;
      let lbl_prg = `${item.type} - ${item.name} - ${prg.size}`;

      return `<div class="menu-item">
			<div><div><img src="${item.img}"></div><div>${item.name}</div>
			</div><div>${item.descr}</div>
			<div>
				<div act="add2order" id="${prg.id}" cost="${prg.cost}" lbl="${lbl_prg}" title="Click to order">${prg.txt}</div>
				<div act="add2order" id="${plg.id}" cost="${plg.cost}" lbl="${lbl_plg}" title="Click to order">${plg.txt}</div>
			</div>
			</div>`;

   },

   GetOrderItem:function(item){

      return `<div class="order-item" cost="${item.cost}" lbl="${item.lbl}" title="Click to remove">
			<div>${item.lbl}</div><div>$${item.cost}</div></div>`;

   },

   GetOrderDetailsItem:function(item){

      return `<div class="sd-item-details"><div>${item.lbl}</div><div>$${item.cost}</div></div>`;

   },

   GetAddressSelector:function(id, adrs){

   	let buff = "<option value=\"\" selected=\"selected\">--- Select Address ---</option>";
		adrs.forEach((adr, idx) => {
			buff += `<option value="${idx}">${adr.street}</option>`;
		});

		return `<select id="${id}">${buff}</select>`;

   },

	GetOpenOrder:function(item){

		let buff = "";
		let order = JSON.parse(item.Order);
		let addrs = JSON.parse(item.Address);

		order.forEach((elm) => {
			buff += `<div class="order-item">${elm.lbl}, $${elm.cost}</div>`;
		});

		return `<div class="order-details" id="OID_${item.RowID}">
				<div class="order-details-list">
					${buff}
				<div class="order-details-adrs">
					<div>${addrs.street}</div>
					<div>${addrs.city}, ${addrs.zcode}</div>
				</div>
				<div class="order-details-ctrls">
					<input type="button" class="btn-making" value="Making" rowid="${item.RowID}"/>
					<input type="button" class="btn-cooking" value="Cooking" rowid="${item.RowID}"/>
					<input type="button" class="btn-delivery" value="Delivery" rowid="${item.RowID}"/>
					<input type="button" class="btn-cancel" value="Cancel" rowid="${item.RowID}"/>
					<div>OrderID: ${item.RowID}</div>
				</div>
			</div>`;

	}

}