
var Shop = {

	HeartbeatTimer:null,
   HeartRate:4000,
   QueueCacheKey:"QueueCache",

   Init:function(){

      $("#btnStart").click(Shop.BtnStart);
      $("#btnStop").click(Shop.BtnStop);

   },

   /*
      page buttons
   */
   BtnStart:function(){

      Shop.HeartbeatTimer = setInterval(Shop.Heartbeat, Shop.HeartRate);
      Shop.Heartbeat();

      $(this).attr("disabled", "disabled");
      $("#btnStop").removeAttr("disabled");

   },

   BtnStop:function(){

      clearInterval(Shop.HeartbeatTimer);
      $(this).attr("disabled", "disabled");
      $("#btnStart").removeAttr("disabled");

   },

   /*
      order event buttons
   */

  	BtnMaking:function(){

   	let rowid = $(this).attr("rowid");
      let backend = new ShopBackend();
      backend.UpdateOrder(rowid, 3, (txt) => {
         console.log(`BtnMaking: ${txt}`);
      });

  	},

  	BtnCooking:function(){
     
   	let rowid = $(this).attr("rowid");
	  	let backend = new ShopBackend();
     	backend.UpdateOrder(rowid, 4, (txt) => {
        	console.log(`BtnCooking: ${txt}`);
	  	});

  	},

  	BtnDelivery:function(){

		let rowid = $(this).attr("rowid");
	  	let backend = new ShopBackend();
     	backend.UpdateOrder(rowid, 5, (txt) => {
        	console.log(`BtnDelivery: ${txt}`);
		  	$(`#OID_${rowid}`).remove();
		  	Shop.UpdateLocalCache(rowid);
	  	});

	},

  	BtnCancel:function(){

		let rowid = $(this).attr("rowid");
	  	let backend = new ShopBackend();
     	backend.UpdateOrder(rowid, 0, (txt) => {
        	console.log(`BtnCancel: ${txt}`);
		  	$(`#OID_${rowid}`).remove();
	  	});

  	},

  	ReadDatabaseQueueCount:function(){

	  	let backend = new ShopBackend();
	  	backend.DatabaseQueueCount((txt) => {
			let msg = `Database Queue: ${txt}`;
		  	$("#OpenOrderCount").html(msg);
	  	});
  	},

	QueuedOrdersCount:function(){

		let len = $(".order-details").length;
	  	console.log(`Local Queue: ${len}`);
	  	return len;
  	
	},

	CacheQueue:function(json){
		
		if(json === undefined)
			return localStorage.getItem(Shop.QueueCacheKey);
		else
			localStorage.setItem(Shop.QueueCacheKey, json);

  	},
	
	Load2LocalOrderQueue:function(json){

		let arr = JSON.parse(json);
		if(arr.length == 0)
			return;

		arr.forEach((item) => {
			let html = HtmlCode.GetOpenOrder(item);
			$("#LocalOrderQueue").append(html);
		});

		/* attach click event handlers to form buttons */
		$(".btn-making").click(Shop.BtnMaking);
		$(".btn-cooking").click(Shop.BtnCooking);
		$(".btn-delivery").click(Shop.BtnDelivery);
		$(".btn-cancel").click(Shop.BtnCancel);

	},

	UpdateLocalCache:function(rowid){

		let json = Shop.CacheQueue();
		let queue = JSON.parse(json);

		let itemIdx = undefined;
		queue.find((item, idx) => {
			if(parseInt(item.RowID) == parseInt(rowid))
				itemIdx = idx;
		});

		let item = undefined;
		let arr = queue.splice(itemIdx, 1);
		if(arr.length == 1)
			item =  arr[0];
		if(parseInt(item.RowID) != parseInt(rowid))
			throw "Wrong order item removed from the queue.";

		json = JSON.stringify(queue);
		Shop.CacheQueue(json);

	},

	LoadDatabaseOrdersQueue:function(){

		let backend = new ShopBackend();
		backend.ReadOpenOrders((json) => {
			Shop.CacheQueue(json);
			Shop.Load2LocalOrderQueue(json);
		});

	},

	ReadLocalQueueCount:function(){

		let cnt = Shop.QueuedOrdersCount();
		$("#LocalQueueCount").html(`Local Queue: ${cnt}`);

	},

	Heartbeat:function(){

		if(Shop.QueuedOrdersCount() == 0)
			Shop.LoadDatabaseOrdersQueue();
		
		Shop.ReadLocalQueueCount();
		Shop.ReadDatabaseQueueCount();

	}	

}
